Lucene++ - a full-featured, c++ search engine
API Documentation

Public Member Functions | Static Public Member Functions | Protected Attributes
Lucene::SpanQueryFilter Class Reference

Constrains search results to only match those which also match a provided query. Also provides position information about where each document matches at the cost of extra space compared with the QueryWrapperFilter. There is an added cost to this above what is stored in a QueryWrapperFilter. Namely, the position information for each matching document is stored. More...

`#include <SpanQueryFilter.h>`

Inheritance diagram for Lucene::SpanQueryFilter:

## Public Member Functions

| SpanQueryFilter (const SpanQueryPtr &query=SpanQueryPtr())
| Constructs a filter which only matches documents matching query. More...
virtual | ~SpanQueryFilter ()
virtual String | getClassName ()
boost::shared_ptr< SpanQueryFilter > | shared_from_this ()
virtual DocIdSetPtr | getDocIdSet (const IndexReaderPtr &reader)
| Creates a DocIdSet enumerating the documents that should be permitted in search results. More...
virtual SpanFilterResultPtr | bitSpans (const IndexReaderPtr &reader)
| Returns a SpanFilterResult with true for documents which should be permitted in search results, and false for those that should not and Spans for where the true docs match. More...
SpanQueryPtr | getQuery ()
virtual String | toString ()
| Returns a string representation of the object. More...
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
Public Member Functions inherited from Lucene::SpanFilter
virtual | ~SpanFilter ()
boost::shared_ptr< SpanFilter > | shared_from_this ()
Public Member Functions inherited from Lucene::Filter
virtual | ~Filter ()
boost::shared_ptr< Filter > | shared_from_this ()
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object. More...
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()
Static Public Member Functions inherited from Lucene::SpanFilter
static String | _getClassName ()
Static Public Member Functions inherited from Lucene::Filter
static String | _getClassName ()

## Protected Attributes

SpanQueryPtr | query
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Additional Inherited Members

Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Detailed Description

Constrains search results to only match those which also match a provided query. Also provides position information about where each document matches at the cost of extra space compared with the QueryWrapperFilter. There is an added cost to this above what is stored in a QueryWrapperFilter. Namely, the position information for each matching document is stored.

This filter does not cache. See the CachingSpanFilter for a wrapper that caches.

## Constructor & Destructor Documentation

## ◆ SpanQueryFilter()

Lucene::SpanQueryFilter::SpanQueryFilter | ( | const SpanQueryPtr & | query = `SpanQueryPtr()` | ) |

Constructs a filter which only matches documents matching query.

Parameters

  query | The SpanQuery to use as the basis for the Filter.

## ◆ ~SpanQueryFilter()

virtual Lucene::SpanQueryFilter::~SpanQueryFilter | ( |  | ) |

virtual

## Member Function Documentation

## ◆ _getClassName()

static String Lucene::SpanQueryFilter::_getClassName | ( |  | ) |

inline static

## ◆ bitSpans()

virtual SpanFilterResultPtr Lucene::SpanQueryFilter::bitSpans | ( | const IndexReaderPtr & | reader | ) |

virtual

Returns a SpanFilterResult with true for documents which should be permitted in search results, and false for those that should not and Spans for where the true docs match.

Parameters

  reader | The IndexReader to load position and DocIdSet information from

Returns
  A SpanFilterResult

Implements Lucene::SpanFilter.

## ◆ equals()

virtual bool Lucene::SpanQueryFilter::equals | ( | const LuceneObjectPtr & | other | ) |

virtual

Return whether two objects are equal.

Reimplemented from Lucene::LuceneObject.

## ◆ getClassName()

virtual String Lucene::SpanQueryFilter::getClassName | ( |  | ) |

inline virtual

Reimplemented from Lucene::SpanFilter.

## ◆ getDocIdSet()

virtual DocIdSetPtr Lucene::SpanQueryFilter::getDocIdSet | ( | const IndexReaderPtr & | reader | ) |

virtual

Creates a DocIdSet enumerating the documents that should be permitted in search results.

Note: null can be returned if no documents are accepted by this Filter.

Note: This method will be called once per segment in the index during searching. The returned DocIdSet must refer to document IDs for that segment, not for the top-level reader.

Parameters

  reader | a IndexReader instance opened on the index currently searched on. Note, it is likely that the provided reader does not represent the whole underlying index ie. if the index has more than one segment the given reader only represents a single segment.

Returns
  a DocIdSet that provides the documents which should be permitted or prohibited in search results. NOTE: null can be returned if no documents will be accepted by this Filter.

See also
  DocIdBitSet

Implements Lucene::Filter.

## ◆ getQuery()

SpanQueryPtr Lucene::SpanQueryFilter::getQuery | ( |  | ) |

## ◆ hashCode()

virtual int32_t Lucene::SpanQueryFilter::hashCode | ( |  | ) |

virtual

Return hash code for this object.

Reimplemented from Lucene::LuceneObject.

## ◆ shared_from_this()

boost::shared_ptr< SpanQueryFilter > Lucene::SpanQueryFilter::shared_from_this | ( |  | ) |

inline

## ◆ toString()

virtual String Lucene::SpanQueryFilter::toString | ( |  | ) |

virtual

Returns a string representation of the object.

Reimplemented from Lucene::LuceneObject.

## Field Documentation

## ◆ query

SpanQueryPtr Lucene::SpanQueryFilter::query

protected

The documentation for this class was generated from the following file:

- SpanQueryFilter.h

clucene.sourceforge.net